Program UserBirthday;
uses Dos;

{
Title   : BIRTHDAY.PAS   (Sends LOCAL messages to users whose birthday is today)
Version : 1.0 -- *ONLY* For Opus 1.7x or above (see _User record below)
LastEdit: October 4, 1991  --  To my great Boss!
Author  : Gianfranco "Frankie" Lanzilli - CoSysOp on ]\/[imac Opus BBs (+39-6-2751446) *Rome,Italy* - 2:335/12@fidonet.org
System  : Borland Turbo Pascal version 5.5 (under MS-DOS environment)
}

const MaxDimMsg = 8192;
      PID       = #1+'PID: Frankie''s BirthDay v1.0';

type _User = record
               Name          : array [0..35] of char;                  { User's Name }
               City          : array [0..35] of char;                  { User's City }
               Pwd           : array [0..15] of char;                  { User's Password }
               UsrTel        : array [0..15] of char;                  { User's Telephone }
               Alias         : array [0..31] of char;                  { User's Alias }
               Times         : word;                                   { Number of times the user has called }
               ClassPriv     : char;                                   { User's Privilege level }
               Help          : char;                                   { User's Help level }
               Tabs          : char;                                   { Expand tabs or not }
               Language      : char;                                   { User's language code }
               Nulls         : word;                                   { Number of NULLs to send at start of line }
               Msg           : word;                                   { Current message area number }
               Bits          : word;                                   { Bit Flags }
               ClassLock     : longint;                                { User's Classlock; Controls access }
               LUDate        : longint;                                { Last time online, in seconds from 1-1-1980 }
               Time          : integer;                                { Time online today }
               Flag          : word;                                   { Series of user flags }
               Upld          : longint;                                { Number of K-bytes uploaded by user }
               Dnld          : longint;                                { Number of K-bytes downloaded by user }
               Dnldl         : integer;                                { Number of K-Bytes downloaded today }
               Files         : word;                                   { Current file area number }
               Width         : char;                                   { User's screen width - 2 }
               Len           : char;                                   { User's screen height }
               Credit        : word;                                   { Net mail credit }
               Debit         : word;                                   { Net mail debit. Users must have credit-debit }
               SpcOEC        : array [0..7] of char;                   { Custom for OEC for user }
               SAcCnt        : array [1..5] of char;                   { Special Announcement counters }
               ExFlag        : char;                                   { Expiration flags. How will it happen? }
               XUDate        : longint;                                { Expiration date in seconds since 1-1-90 }
               CrMin         : longint;                                { Expiration credit in minutes of access }
               DbMin         : longint;                                { Expiration credit time used so far }
               U_Section     : array [0..15] of char;                  { Title of current Section }
               U_Likes       : array [0..15] of char;                  { Last character string searched for }
               FUDate        : longint;                                { First used date in seconds since 1-1-90 }
               Caller_ID     : longint;                                { This user's serial number }
               Section       : longint;                                { What Section the user is currently in }
               Menu_Mode     : word;                                   { What menu the user is looking at }
               TwoBits       : word;                                   { More user flags }
               After_Externs : word;                                   { What externals user did }
               MSecs         : char;                                   { Number of message areas in user's Section }
               FSecs         : char;                                   { Number of file areas in user's Section }
               Address       : array [0..31] of char;                  { User's street address }
               My_Ans        : array [0..63] of char;                  { Answer to Sysop's logon question }
               StrFill       : array [0..31] of char;                  { Empty }
               Bday_Mon      : shortint;                               { User's Birthday month }
               Bday_Day      : shortint;                               { user's Birthday day }
               Bday_Year     : integer;                                { User's Birthday year }
               Messages_Read : longint;                                { Total number of messages read }
               Messages_Sent : longint;                                { Total number of messages entered }
               My_Section    : array [0..79] of word;                  { Areas in User section }
               Big_Fill      : array [0..49] of word;                  { Empty }
               User_Macro    : array [0..31] of char;                  { User keyboard macro }
               Sysop_Comment : array [0..79] of char;                  { Comment by sysop }
               OPUS_ID       : longint;                                { Check for valid LASTUSER.DAT }
               Extern_ID     : array [0..6] of longint;                { What externals are leaving stuff in LASTUSER.DAT }
               Extern_Inf    : array [0..6] of array [0..31] of char;  { External Infos (7 lines of 32 chars) }
             end;                                                      { LENGTH OF ALL THE RECORD STRUCTURE = 1024 bytes }

var User                                                                                        : _User;
    UserFile                                                                                    : file of _User;
    CfgName, SysOp, Address, UserFileName, MsgPath, MsgSubject, MsgContent, MsgOrigin, UserName : string;
    NumRead, Year, Month, Day, DoW, Zone, Net, Node, Point                                      : word;
    NumYears                                                                                    : integer;
    Time                                                                                        : longint;
    TextBuff                                                                                    : array [1..MaxDimMsg] of char;

procedure CheckCommandLine (var S : string);
  begin  {CheckCommandLine}
    if (ParamCount < 1) then
      S := 'BIRTHDAY.CFG'
    else
      S := ParamStr(1);
  end;  {CheckCommandLine}

procedure AnalizeCfgFile (W : string; var Sy, Ad, UF, MP, MS, MC, MO : string);
  const S = 'SYSOP';
        A = 'ADDRESS';
        U = 'USERFILE';
        P = 'MSGPATH';
        J = 'MSGSUBJECT';
        C = 'MSGCONTENT';
        R = 'MSGORIGIN';
  var F         : text;
      Line, Old : string;
      I         : byte;
      Exit      : boolean;

  procedure RemoveBlanks (var T : string);
    begin  {RemoveBlanks}
      while ((T[1] = #8) or (T[1] = #32)) do
        T := Copy(T,2,Length(T));
      while ((T[Length(T)] = #8) or (T[Length(T)] = #32)) do
        T := Copy(T,1,(Length(T)-1))
    end;  {RemoveBlanks}

  procedure MissingWarn (X : string; var E : boolean);
    begin  {MissingWarn}
      Writeln(#7,'Error: ',X,' not specified in configuration file.');
      E := true
    end;  {MissingWarn}

  begin  {AnalizeCfgFile}
    Assign(F,W);
    {$I-} Reset(F); {$I+}
    if (IOResult <> 0) then
      begin
        Writeln(#7,'Error: Configuration file "',W,'" is missing.');
        Halt
      end;
    Sy := '';
    Ad := '';
    UF := '';
    MP := '';
    MS := '';
    MC := '';
    MO := '';
    while (not Eof(F)) do
      begin
        Readln(F,Line);
        if (Length(Line) <> 0) then
          begin
            I := 1;
            while ((Line[I] = #8) or (Line[I] = #32)) do
              Inc(I);
            if (Line[I] <> ';') then
              begin
                Old := Line;
                for I := 1 to Length(Line) do
                  Line[I] := UpCase(Line[I]);
                if (Pos(S,Line) > 0) then
                  Sy := Copy(Old,(Pos(S,Line)+Length(S)+1),255)
                else
                  if (Pos(A,Line) > 0) then
                    Ad := Copy(Old,(Pos(A,Line)+Length(A)+1),255)
                  else
                    if (Pos(U,Line) > 0) then
                      UF := Copy(Line,(Pos(U,Line)+Length(U)+1),255)
                    else
                      if (Pos(P,Line) > 0) then
                        MP := Copy(Line,(Pos(P,Line)+Length(P)+1),255)
                      else
                        if (Pos(J,Line) > 0) then
                          MS := Copy(Old,(Pos(J,Line)+Length(J)+1),255)
                        else
                          if (Pos(C,Line) > 0) then
                            MC := Copy(Line,(Pos(C,Line)+Length(C)+1),255)
                          else
                            if (Pos(R,Line) > 0) then
                              MO := Copy(Old,(Pos(R,Line)+Length(R)+1),255)
                            else
                              begin
                                Writeln(#7,'Error in configuration file "',W,'" at line:');
                                Writeln(Old);
                                Halt
                              end
            end
          end
      end;
    Close(F);
    RemoveBlanks(Sy);
    RemoveBlanks(Ad);
    RemoveBlanks(UF);
    RemoveBlanks(MP);
    RemoveBlanks(MS);
    RemoveBlanks(MC);
    RemoveBlanks(MO);
    if (Length(MP) > 0) then
      if (MP[Length(MP)] <> '\') then
        MP := MP + '\';
    if (Length(MS) > 72) then
      MS := Copy(MS,1,72);
    if (Length(MO) > 50) then
      MO := Copy(MO,1,50);
    { Check for existence of mandatory parms }
    Exit := false;
    if (Sy = '') then
      MissingWarn(S,Exit);
    if (Ad = '') then
      MissingWarn(A,Exit);
    if (UF = '') then
      MissingWarn(U,Exit);
    if (MP = '') then
      MissingWarn(P,Exit);
    if (MC = '') then
      MissingWarn(C,Exit);
    if Exit then
      Halt
  end;  {AnalizeCfgFile}

procedure CheckConfig (Ad, UF, MP, MC : string; var Zo, Ne, No, Po : word);
  var D    : SearchRec;
      C, K : byte;
      E    : integer;
      F    : text;

  procedure IllegalAddress;
    begin  {IllegalAddress}
      Writeln(#7,'Error: Illegal address "',Ad,'" in configuration file.');
      Halt
    end;  {IllegalAddress}

  begin  {CheckConfig}
    { Checking Address }
    C := 1;
    K := C;
    while (Ad[K] <> ':') do
      Inc(K);
    Val(Copy(Ad,C,(K-C)),Zo,E);
    if (E > 0) then
      IllegalAddress;
    C := K + 1;
    K := C;
    while (Ad[K] <> '/') do
      Inc(K);
    Val(Copy(Ad,C,(K-C)),Ne,E);
    if (E > 0) then
      IllegalAddress;
    C := K + 1;
    K := C;
    while ((Ad[K] >= '0') and (Ad[K] <= '9')) do
      Inc(K);
    Val(Copy(Ad,C,(K-C)),No,E);
    if (E > 0) then
      IllegalAddress;
    C := K + 1;
    K := C;
    if ((Length(Ad) >= (K-1)) and (Ad[K-1] = '.')) then
      begin
        while ((Ad[K] >= '0') and (Ad[K] <= '9')) do
          Inc(K);
        Val(Copy(Ad,C,(K-C)),Po,E);
        if (E > 0) then
          IllegalAddress
      end
    else
      Po := 0;
    { Checking UserFile }
    Assign(F,UF);
    {$I-}  Reset(F);  {$I+}
    if (IOResult <> 0) then
      begin
        Writeln(#7,'Error: UserFile "',UF,'" is wrong or missing.');
        Halt
      end
    else
      Close(F);
    { Checking MsgPath }
    FindFirst(MP+'*.*',AnyFile,D);
    if (DosError = 3) then
      begin
        Writeln(#7,'Error: MsgPath "',MP,'" is wrong or missing.');
        Halt
      end;
    { Checking MsgContent (file) }
    Assign(F,MC);
    {$I-}  Reset(F);  {$I+}
    if (IOResult <> 0) then
      begin
        Writeln(#7,'Error: MsgContent File "',MC,'" is wrong or missing.');
        Halt
      end
    else
      Close(F)
  end;  {CheckConfig}

procedure GetMsgContent (MC : string);
  var F : file;
  begin  {GetMsgContent}
    Assign(F,MC);
    Reset(F,1);
    BlockRead(F,TextBuff,MaxDimMsg,NumRead);
    Close(F)
  end;  {GetMsgContent}

function Date_Time (PackIt : boolean) : string;
  var Yr, Mn, Dy, DW, Hr, Mt, Sc, SH : word;
      S, Aux                         : string;
      DT                             : DateTime;

  procedure AT0IN (C : word; var T : string);
    begin  {AT0IN}
      if (C < 10) then
        T := '0' + T
    end;  {AT0IN}

  begin  {Date_Time}
    GetDate(Yr,Mn,Dy,DW);
    if PackIt then
      begin
        DT.Year  := Yr;
        DT.Month := Mn;
        DT.Day   := Dy
      end;
    Str(Dy,Aux);
    AT0IN(Dy,Aux);
    S :=  Aux + ' ';
    case Mn of
       1 : Aux := 'Jan';   2 : Aux := 'Feb';   3 : Aux := 'Mar';
       4 : Aux := 'Apr';   5 : Aux := 'May';   6 : Aux := 'Jun';
       7 : Aux := 'Jul';   8 : Aux := 'Aug';   9 : Aux := 'Sep';
      10 : Aux := 'Oct';  11 : Aux := 'Nov';  12 : Aux := 'Dec'
    end;
    S := S + Aux + ' ';
    if (Yr < 2000) then
      Yr := Yr - 1900
    else
      Yr := Yr - 2000;
    Str(Yr,Aux);
    AT0IN(Yr,Aux);
    S := S + Aux + '  ';
    GetTime(Hr,Mt,Sc,SH);
    if PackIt then
      begin
        DT.Hour := Hr;
        DT.Min  := Mt;
        DT.Sec  := Sc
      end;
    Str(Hr,Aux);
    AT0IN(Hr,Aux);
    S := S + Aux + ':';
    Str(Mt,Aux);
    AT0IN(Mt,Aux);
    S := S + Aux + ':';
    Str(Sc,Aux);
    AT0IN(Sc,Aux);
    S := S + Aux;
    Date_Time := S;
    if PackIt then
      PackTime(DT,Time)
  end;  {Date_Time}

procedure WriteMsg (MP, Sy, ToName, MsgSubj : string; Years : integer; MO, Ad : string; Cl_ID, Zo, Ne, No, Po : word);
  var Msg      : file;
      GP, AS   : string;
      MsgNumW  : word;
      Header   : array [1..190]  of char;

  procedure FillTextField (CF : string; St, Le : byte);
    var J : byte;
    begin  {FillTextField}
      for J := 1 to Length(CF) do
        Header[J+St] := CF[J];
      for J := Succ(Length(CF)) to Le do
        Header[J+St] := #0
    end;  {FillTextField}

  function LastMsgNumber (Path : string) : word;
    var Max, Cnt : word;
        Err      : integer;
        DirInfo  : SearchRec;
    begin  {LastMsgNumber}
      Max := 0;
      FindFirst(Path+'*.MSG',AnyFile,DirInfo);
      while (DosError = 0) do
        begin
          Val(Copy(Dirinfo.Name,1,(Pos('.',DirInfo.Name)-1)),Cnt,Err);
          if ((Err = 0) and (Cnt > Max)) then
            Max := Cnt;
          FindNext(DirInfo)
        end;
      LastMsgNumber := Max
    end;  {LastMsgNumber}

  procedure LineWrite (var G : file; Line : string);
    var J        : byte;
        LineBuff : array [1..255]  of char;
    begin  {LineWrite}
      for J := 1 to Length(Line) do
        LineBuff[J] := Line[J];
      BlockWrite(G,LineBuff,Length(Line))
    end;  {LineWrite}

  begin  {WriteMsg}
    GP := MsgSubj;
    MsgNumW := Pos('%#',GP);
    if (MsgNumW > 0) then
      begin
        Delete(GP,MsgNumW,Length('%#'));
        Str(Years,AS);
        Insert(AS,GP,MsgNumW)
      end;
    FillTextField(Sy,0,36);                        {From:}
    FillTextField(ToName,36,36);                   {To:}
    FillTextField(GP,72,72);                       {Subject:}
    FillTextField(Date_Time(true),144,20);         {DateTime}
    Header[165] := Chr(0);                         {TimesRead}
    Header[166] := Chr(0);
    Header[167] := Chr(No mod 256);                {DestNode}
    Header[168] := Chr(No div 256);
    Header[169] := Header[167];                    {OrigNode}
    Header[170] := Header[168];
    Header[171] := Chr(0);                         {Cost}
    Header[172] := Chr(0);
    Header[173] := Chr(Ne mod 256);                {OrigNet}
    Header[174] := Chr(Ne div 256);
    Header[175] := Header[173];                    {DestNet}
    Header[176] := Header[174];
    Header[177] := Chr((Time div 65536) mod 256);  {DestZone}
    Header[178] := Chr((Time div 65536) div 256);
    Header[179] := Chr((Time mod 65536) mod 256);  {OrigZone}
    Header[180] := Chr((Time mod 65536) div 256);
    Header[181] := Header[177];                    {DestPoint}
    Header[182] := Header[178];
    Header[183] := Header[179];                    {OrigPoint}
    Header[184] := Header[180];
    Header[185] := Chr(0);                         {ReplyTo}
    Header[186] := Chr(0);
    Header[187] := Chr((1+128+256) mod 256);       {Attribute: Private + Kill/Sent + Local}
    Header[188] := Chr((1+128+256) div 256);
    Header[189] := Chr(0);                         {NextReply}
    Header[190] := Chr(0);
    MsgNumW := Succ(LastMsgNumber(MP));
    Str(MsgNumW,GP);
    Assign(Msg,(MP+GP+'.MSG'));
    {$I-} Rewrite(Msg,1); {$I-}
    if (IOResult <> 0) then
      Writeln(#7,Date_Time(false),'  Can''t write msg #',GP,' in ',MP,' to ',ToName,'.')
    else
      begin
        BlockWrite(Msg,Header,190);
        if ((MO <> '') and (Po > 0)) then
          begin
            Str(Point,GP);
            LineWrite(Msg,#1+'FMPT '+GP+#13);
            LineWrite(Msg,#1+'TOPT '+GP+#13)
          end;
        LineWrite(Msg,PID+#13+#13);
        if (Pos(' ',ToName) > 0) then
          GP := Copy(ToName,1,Pred(Pos(' ',ToName)))
        else
          GP := ToName;
        LineWrite(Msg,'Hello, '+GP+'!'+#13+#13);
        BlockWrite(Msg,TextBuff,NumRead);
        LineWrite(Msg,#13+'--- Frankie''s ]\/[imacSoft'+#13);
        if (MO <> '') then
          LineWrite(Msg,' * Origin: '+MO+' ('+Ad+')'+#13);
        LineWrite(Msg,#13+#0);
        Close(Msg);
        Writeln(Date_Time(false),'  Written message #',MsgNumW,' to ',ToName,' (User #',Cl_ID,')')
      end;
  end;  {WriteMsg}

begin  {MAIN}
  Writeln(Date_Time(false),'  Begin, Frankie''s BirthDay v1.0 [for Opus 1.7x+]...');
  CheckCommandLine(CfgName);
  AnalizeCfgFile(CfgName,SysOp,Address,UserFileName,MsgPath,MsgSubject,MsgContent,MsgOrigin);
  CheckConfig(Address,UserFileName,MsgPath,MsgContent,Zone,Net,Node,Point);
  GetMsgContent(MsgContent);
  GetDate(Year,Month,Day,DoW);
  Assign(UserFile,UserFileName);
  Reset(UserFile);
  Writeln(Date_Time(false),'  Scanning User File ',UserFileName);
  while (not Eof(UserFile)) do
    begin
      Read(UserFile,User);
      if ((User.Bday_Mon = Month) and (User.Bday_Day = Day)) then
        begin
          UserName := '';
          DoW := 0;
          while ((DoW <= 35) and (User.Name[DoW] <> #0)) do
            begin
              UserName := UserName + User.Name[DoW];
              Inc(DoW)
            end;
          NumYears := Year - User.Bday_Year;
          WriteMsg(MsgPath,SysOp,UserName,MsgSubject,NumYears,MsgOrigin,Address,User.Caller_ID,Zone,Net,Node,Point)
        end
    end;
  Close(UserFile);
  Writeln(Date_Time(false),'  Scan completed.');
  Writeln(Date_Time(false),'  End, Frankie''s BirthDay v1.0...');
  Writeln
end.  {MAIN}